package com.zanehuy.bookaccounter;

import java.io.IOException;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.google.appengine.api.datastore.DatastoreService;
import com.google.appengine.api.datastore.DatastoreServiceFactory;
import com.google.appengine.api.datastore.Entity;
import com.google.appengine.api.datastore.KeyFactory;

public class AddBookServlet extends HttpServlet {

	private static final long serialVersionUID = 1L;
	private DatastoreService datastore;

	public AddBookServlet() {
		datastore = DatastoreServiceFactory.getDatastoreService();
	}

	@Override
	public void doPost(HttpServletRequest req, HttpServletResponse resp) throws IOException {
		addBook(new Book(Long.parseLong(req.getParameter("id")), req.getParameter("title"), req.getParameter("author")));
		resp.setContentType("text/plain");
		//resp.getWriter().println(addBook());
	}

	private void addBook(Book book) {
		Entity bookEntity = new Entity(KeyFactory.createKey("books", book.getId()));
		bookEntity.setProperty("title", book.getTitle());
		bookEntity.setProperty("author", book.getAuthor());
		datastore.put(bookEntity);
	}
}
