package com.zanehuy.bookaccounter;

import java.io.IOException;
import java.util.ArrayList;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.google.appengine.api.datastore.DatastoreService;
import com.google.appengine.api.datastore.DatastoreServiceFactory;
import com.google.appengine.api.datastore.Entity;
import com.google.appengine.api.datastore.PreparedQuery;
import com.google.appengine.api.datastore.Query;

public class GetBooksServlet extends HttpServlet {

	private static final long serialVersionUID = 1L;
	private DatastoreService datastore;

	public GetBooksServlet() {
		datastore = DatastoreServiceFactory.getDatastoreService();
	}

	@Override
	public void doGet(HttpServletRequest req, HttpServletResponse resp) throws IOException {
		GetBooksResponder responder = new GetBooksXmlResponder();
		responder.setBookList(getBooks());
		resp.setContentType("text/xml");
		resp.getWriter().println(responder.generateResponse());
	}

	private ArrayList<Book> getBooks() {
		Query query = new Query("books");
		PreparedQuery prepQuery = datastore.prepare(query);
		ArrayList<Book> bookList = new ArrayList<Book>();

		for (Entity b : prepQuery.asIterable()) {
			bookList.add(new Book(b.getKey().getId(), (String)b.getProperty("title"), (String)b.getProperty("author")));
		}

		return bookList;
	}
}