package com.zanehuy.bookaccounter;

import java.io.StringWriter;
import java.io.Writer;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Text;

public class GetBooksXmlResponder extends GetBooksResponder {

	private Document doc;

	public GetBooksXmlResponder() {
		DocumentBuilderFactory docFact = DocumentBuilderFactory.newInstance();
		DocumentBuilder docBuilder = null;
		try {
			docBuilder = docFact.newDocumentBuilder();
		} catch (ParserConfigurationException e) {
			e.printStackTrace();
		}
		doc = docBuilder.newDocument();
	}

	@Override
	public String generateResponse() {
		Element books = doc.createElement("books");
		doc.appendChild(books);

		for (Book b : bookList) {
			Element book = doc.createElement("book");
			Element title = doc.createElement("title"), author = doc.createElement("author");
			Text titleText = doc.createTextNode(b.getTitle());
			Text authorText = doc.createTextNode(b.getAuthor());

			title.appendChild(titleText);
			author.appendChild(authorText);

			book.setAttribute("id", Long.toString(b.getId()));
			book.appendChild(title);
			book.appendChild(author);
			books.appendChild(book);
		}

		return transform();
	}

	private String transform() {
        TransformerFactory transfac = TransformerFactory.newInstance();
        Transformer trans = null;
		try {
			trans = transfac.newTransformer();
		} catch (TransformerConfigurationException e) {
			e.printStackTrace();
		}
        trans.setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "yes");
        trans.setOutputProperty(OutputKeys.INDENT, "yes");

        Writer writer = new StringWriter();
        StreamResult result = new StreamResult(writer);
        try {
			trans.transform(new DOMSource(doc), result);
		} catch (TransformerException e) {
			e.printStackTrace();
		}

        return writer.toString();
	}
}
